package com.diagbot.entity.node;

import lombok.Data;
import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "年龄")
public class Age extends BaseNode  {

    @Property(name = "最大值")
    private Integer maxval;

    @Property(name = "最小值")
    private Integer minval;

    @Relationship(type="疾病相关年龄", direction = Relationship.INCOMING)
    private Set<Disease> diseases;

    @Relationship(type="药品通用名禁忌年龄", direction = Relationship.INCOMING)
    private Set<Medicine> medicines;

    @Relationship(type = "辅助检查禁忌年龄", direction = Relationship.INCOMING)
    private Set<PACS> pacs;

    @Relationship(type="实验室检查禁忌年龄", direction = Relationship.INCOMING)
    private Set<LIS> lis;
}

