package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = true)
@NodeEntity(label = "临床表现")
public class ClinicalFinding extends BaseNode  {

    @Property(name = "最大值")
    private Double maxval;

    @Property(name = "最小值")
    private Double minval;

    @Property(name = "单位")
    private String unit;

    @Relationship(type="药品通用名禁忌临床表现", direction = Relationship.INCOMING)
    private Set<Medicine> medicines;

    @Relationship(type="辅助检查禁忌临床表现", direction = Relationship.INCOMING)
    private Set<PACS> pacs;

    @Relationship(type="实验室检查禁忌临床表现", direction = Relationship.INCOMING)
    private Set<ClinicalFinding> clinicalfindings;

}
