package com.diagbot.entity.node;

import lombok.Data;
import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "疾病")
public class Disease extends BaseNode  {

    @Relationship(type="疾病相关年龄", direction = Relationship.OUTGOING)
    private Age age;

    @Relationship(type="疾病相关性别", direction = Relationship.OUTGOING)
    private Gender gender;

    @Relationship(type="疾病相关治愈率", direction = Relationship.OUTGOING)
    private CureRate curerate;

    @Relationship(type="疾病相关治疗周期", direction = Relationship.OUTGOING)
    private TreatCycle treatcycle;

    @Relationship(type="疾病相关传染途径", direction = Relationship.OUTGOING)
    private Set<Infection> infections = new HashSet<>();

    @Relationship(type="疾病相关多发人群", direction = Relationship.OUTGOING)
    private Set<Group> groups = new HashSet<>();

    @Relationship(type="疾病相关别名", direction = Relationship.OUTGOING)
    private Set<Alias> alias = new HashSet<>();

    @Relationship(type="疾病相关体征", direction = Relationship.OUTGOING)
    private Set<Vital> vitals = new HashSet<>();

    @Relationship(type="疾病相关科室", direction = Relationship.OUTGOING)
    private Set<Dept> depts = new HashSet<>();

    @Relationship(type="疾病相关症状", direction = Relationship.OUTGOING)
    private Set<Symptom> symptoms = new HashSet<>();

    @Relationship(type="疾病相关发病情况", direction = Relationship.OUTGOING)
    private Set<Situation> situations = new HashSet<>();

    @Relationship(type="疾病相关编码", direction = Relationship.OUTGOING)
    private Code code;

    @Relationship(type="疾病相关标准科室", direction = Relationship.OUTGOING)
    private Set<Dept> stddepts = new HashSet<>();

    @Relationship(type="疾病相关并发症", direction = Relationship.OUTGOING)
    private Set<Complication> complications = new HashSet<>();

    @Relationship(type="疾病相关检查", direction = Relationship.OUTGOING)
    private Set<PACS> pacss = new HashSet<>();

    @Relationship(type="疾病相关药品", direction = Relationship.OUTGOING)
    private Set<Medicine> medicines = new HashSet<>();

    @Relationship(type="疾病相关发病原因", direction = Relationship.OUTGOING)
    private Set<Cause> causes = new HashSet<>();

    @Relationship(type="疾病相关鉴别诊断", direction = Relationship.OUTGOING)
    private Set<Disease> diff_diseases = new HashSet<>();

    @Relationship(type="疾病相关手术和操作", direction = Relationship.OUTGOING)
    private Set<Operation> operations = new HashSet<>();

    @Relationship(type="疾病相关病原体", direction = Relationship.OUTGOING)
    private Set<Pathogen> pathogens = new HashSet<>();

    @Relationship(type="疾病相关遗传性", direction = Relationship.OUTGOING)
    private Set<Heredity> hereditys = new HashSet<>();

    @Relationship(type="疾病相关治疗", direction = Relationship.OUTGOING)
    private Set<Treatment> treatments = new HashSet<>();

    @Relationship(type="疾病相关分型", direction = Relationship.OUTGOING)
    private Set<DiseaseType> diseasetypes = new HashSet<>();

    @Relationship(type="疾病相关局部并发症", direction = Relationship.OUTGOING)
    private Set<Complication> localcompls = new HashSet<>();

    @Relationship(type="疾病相关全身并发症", direction = Relationship.OUTGOING)
    private Set<Complication> generalcompls = new HashSet<>();

    @Relationship(type="疾病相关化验", direction = Relationship.OUTGOING)
    private Set<LIS> liss = new HashSet<>();

    @Relationship(type="疾病相关实验室检查", direction = Relationship.OUTGOING)
    private Set<LIS> liss_dis = new HashSet<>();

    @Relationship(type="疾病相关辅助检查", direction = Relationship.OUTGOING)
    private Set<PACS> pacs = new HashSet<>();

    @Relationship(type="疾病相关药品名及编码", direction = Relationship.OUTGOING)
    private Medicine_Code medicine_code;

    @Relationship(type="药品通用名禁忌疾病", direction = Relationship.INCOMING)
    private Set<Medicine> medicine_conflict_diseases;

    @Relationship(type="辅助检查禁忌疾病", direction = Relationship.INCOMING)
    private Set<PACS> pacs_conflict_diseases;

    @Relationship(type="实验室检查禁忌疾病", direction = Relationship.INCOMING)
    private Set<Disease> lis_conflict_diseases;
}






