package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "医保ICD_10疾病")
public class ICDDisease extends BaseNode  {

    @Property(name="医保ICD-10代码")
    private String icdcode;

    @Property(name="疾病名称")
    private String othername;

    @Property(name="静态知识")
    private String knowledge;

    @Relationship(type="医保ICD-10疾病相关实验室检查", direction = Relationship.OUTGOING)
    private Set<LIS> liss_dis = new HashSet<>();

    @Relationship(type="医保ICD-10疾病相关辅助检查", direction = Relationship.OUTGOING)
    private Set<PACS> pacs = new HashSet<>();

    @Relationship(type="医保ICD-10疾病相关实验室检查套餐", direction = Relationship.OUTGOING)
    private Set<LISPack> lispack_dis = new HashSet<>();

}






