package com.diagbot.entity.node;

import lombok.Data;
import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "实验室检查")
public class LIS extends BaseNode  {

    @Property(name = "最大值")
    private Double maxval;

    @Property(name = "最小值")
    private Double minval;

    @Property(name = "单位")
    private String unit;

    @Relationship(type="实验室检查项目相关套餐", direction = Relationship.OUTGOING)
    private Set<LISPack> lisPacks = new HashSet<>();

    @Relationship(type="实验室检查相关实验室检查危急值", direction = Relationship.OUTGOING)
    private Set<LISCritical> liscritial = new HashSet<>();

    @Relationship(type="实验室检查禁忌性别", direction = Relationship.OUTGOING)
    private Gender gender;

    @Relationship(type="实验室检查禁忌年龄", direction = Relationship.OUTGOING)
    private Age age;

    @Relationship(type="实验室检查禁忌临床表现", direction = Relationship.OUTGOING)
    private Set<ClinicalFinding> clinicalfindings = new HashSet<>();

    @Relationship(type="实验室检查禁忌体征", direction = Relationship.OUTGOING)
    private Set<Vital> vitals = new HashSet<>();

    @Relationship(type="实验室检查禁忌服用药品", direction = Relationship.OUTGOING)
    private Set<Medicine> conflict_medicines = new HashSet<>();

    @Relationship(type="实验室检查禁忌过敏药品", direction = Relationship.OUTGOING)
    private Set<AllergicMed> allergicmeds = new HashSet<>();

    @Relationship(type="实验室检查禁忌手术和操作", direction = Relationship.OUTGOING)
    private Set<Operation> operations = new HashSet<>();

    @Relationship(type="实验室检查禁忌操作", direction = Relationship.OUTGOING)
    private Set<Procedure> procedures = new HashSet<>();

    @Relationship(type="实验室检查禁忌辅助检查", direction = Relationship.OUTGOING)
    private Set<PACS> pacs = new HashSet<>();

    @Relationship(type="实验室检查禁忌疾病", direction = Relationship.OUTGOING)
    private Set<Disease> diseases = new HashSet<>();

    @Relationship(type="实验室检查禁忌人群", direction = Relationship.OUTGOING)
    private Set<Group> groups = new HashSet<>();

    @Relationship(type="疾病相关化验", direction = Relationship.INCOMING)
    private Set<Disease> disease_related_inspect;

    @Relationship(type="疾病相关实验室检查", direction = Relationship.INCOMING)
    private Set<Disease> disease_related_lis;

    @Relationship(type="药品通用名禁忌实验室检查", direction = Relationship.INCOMING)
    private Set<Medicine> medicine_conflict_lis;

    @Relationship(type="辅助检查禁忌实验室检查", direction = Relationship.INCOMING)
    private Set<PACS> pacs_conflict_lis;

    @Relationship(type="医保ICD-10疾病相关实验室检查", direction = Relationship.INCOMING)
    private Set<Disease> icddis_related_lis = new HashSet<>();

    @Relationship(type="实验室检查套餐相关实验室检查", direction = Relationship.INCOMING)
    private Set<LISPack> lisPacks_related_lis = new HashSet<>();
}


