package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.util.*;

@Setter
@Getter
@EqualsAndHashCode(callSuper = true)
@NodeEntity(label = "药品通用名")
public class Medicine extends BaseNode implements Serializable {

    @Property(name = "高危级别")
    private String risklevel;

    @Relationship(type = "药品通用名禁忌性别", direction = Relationship.OUTGOING)
    private Gender gender;

    @Relationship(type = "药品通用名禁忌年龄", direction = Relationship.OUTGOING)
    private Age age;

    @Relationship(type = "药品通用名禁忌临床表现", direction = Relationship.OUTGOING)
    private Set<ClinicalFinding> clinicalfindings = new HashSet<>();

    @Relationship(type = "药品通用名禁忌体征", direction = Relationship.OUTGOING)
    private Set<Vital> vitals = new HashSet<>();

    @Relationship(type = "药品通用名禁忌实验室检查", direction = Relationship.OUTGOING)
    private Set<LIS> lisset = new HashSet<>();

    @Relationship(type = "药品通用名禁忌辅助检查", direction = Relationship.OUTGOING)
    private Set<PACS> pacs = new HashSet<>();

    @Relationship(type = "药品通用名禁忌过敏药品", direction = Relationship.OUTGOING)
    private Set<AllergicMed> allergicmeds = new HashSet<>();

    @Relationship(type = "药品通用名禁忌手术和操作", direction = Relationship.OUTGOING)
    private Set<Operation> operations = new HashSet<>();

    @Relationship(type = "药品通用名禁忌操作", direction = Relationship.OUTGOING)
    private Set<Procedure> procedures = new HashSet<>();

    @Relationship(type = "药品通用名禁忌疾病", direction = Relationship.OUTGOING)
    private Set<Disease> diseases = new HashSet<>();

    @Relationship(type = "药品通用名禁忌人群", direction = Relationship.OUTGOING)
    private Set<Group> groups = new HashSet<>();

    @Relationship(type = "药品通用名禁忌配伍", direction = Relationship.OUTGOING)
    private Set<ConflictMed> conflictmeds = new HashSet<>();

    @Relationship(type="疾病相关药品", direction = Relationship.INCOMING)
    private Set<Disease> disease_related_meds;

    @Relationship(type="辅助检查禁忌服用药品", direction = Relationship.INCOMING)
    private Set<PACS> pacs_conflict_medicine;

    @Relationship(type="实验室检查禁忌服用药品", direction = Relationship.INCOMING)
    private Set<Medicine> lis_conflict_medicine;

}


