package com.diagbot.entity.node;

import lombok.Data;
import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "手术和操作")
public class Operation extends BaseNode  {

    @Property(name = "高危级别")
    private String risklevel;

    @Relationship(type="疾病相关手术和操作", direction = Relationship.INCOMING)
    private Set<Disease> diseases;

    @Relationship(type="药品通用名禁忌手术和操作", direction = Relationship.INCOMING)
    private Set<Medicine> medicines;

    @Relationship(type="辅助检查禁忌手术和操作", direction = Relationship.INCOMING)
    private Set<PACS> pacs;

    @Relationship(type="实验室检查禁忌手术和操作", direction = Relationship.INCOMING)
    private Set<LIS> lis;
}


