package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@EqualsAndHashCode(callSuper = true)
@NodeEntity(label = "服用药品")
public class OralMedicine extends BaseNode implements Serializable {

    @Relationship(type="疾病相关药品", direction = Relationship.INCOMING)
    private Set<Disease> disease_related_meds;

    @Relationship(type="药品相关化学物质类别", direction = Relationship.INCOMING)
    private Set<Disease> medicine_related_chem;

    @Relationship(type="辅助检查禁忌服用药品", direction = Relationship.INCOMING)
    private Set<PACS> pacs_conflict_medicine;

    @Relationship(type="实验室检查禁忌服用药品", direction = Relationship.INCOMING)
    private Set<OralMedicine> lis_conflict_medicine;

}


