package com.diagbot.entity.node;

import lombok.Data;
import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "辅助检查")
public class PACS extends BaseNode  {

    /*
    @Property(name = "最大值")
    private BigDecimal maxval;

    @Property(name = "最小值")
    private BigDecimal minval;

    @Property(name = "单位")
    private String unit;
    */

    @Relationship(type = "辅助检查禁忌性别", direction = Relationship.OUTGOING)
    private Gender gender;

    @Relationship(type="辅助检查禁忌年龄", direction = Relationship.OUTGOING)
    private Age age;

    @Relationship(type="辅助检查禁忌临床表现", direction = Relationship.OUTGOING)
    private Set<ClinicalFinding> clinicalfindings = new HashSet<>();

    @Relationship(type="辅助检查禁忌体征", direction = Relationship.OUTGOING)
    private Set<Vital> vitals = new HashSet<>();

    @Relationship(type="辅助检查禁忌服用药品", direction = Relationship.OUTGOING)
    private Set<Medicine> conflict_medicines = new HashSet<>();

    @Relationship(type="辅助检查禁忌过敏药品", direction = Relationship.OUTGOING)
    private Set<AllergicMed> allergicmeds = new HashSet<>();

    @Relationship(type="辅助检查禁忌手术和操作", direction = Relationship.OUTGOING)
    private Set<Operation> operations = new HashSet<>();

    @Relationship(type="辅助检查禁忌操作", direction = Relationship.OUTGOING)
    private Set<Procedure> procedures = new HashSet<>();

    @Relationship(type="辅助检查禁忌实验室检查", direction = Relationship.OUTGOING)
    private Set<LIS> liss = new HashSet<>();

    @Relationship(type="辅助检查禁忌疾病", direction = Relationship.OUTGOING)
    private Set<Disease> diseases = new HashSet<>();

    @Relationship(type="辅助检查禁忌人群", direction = Relationship.OUTGOING)
    private Set<Group> groups = new HashSet<>();


    @Relationship(type="疾病相关辅助检查", direction = Relationship.INCOMING)
    private Set<Disease> disease_related_pacs;

//    @Relationship(type="药品通用名禁忌辅助检查", direction = Relationship.INCOMING)
//    private Set<Medicine> medicine_conflict_pacs = new HashSet<>();

    @Relationship(type="实验室检查禁忌辅助检查", direction = Relationship.INCOMING)
    private Set<LIS> lis_conflict_pacs;

    @Relationship(type="医保ICD-10疾病相关辅助检查", direction = Relationship.INCOMING)
    private Set<Disease> icddis_related_pacs = new HashSet<>();

}





