package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.math.BigDecimal;
import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "体征")
public class Vital extends BaseNode  {

    @Property(name = "最大值")
    private Double maxval;

    @Property(name = "最小值")
    private Double minval;

    @Property(name = "单位")
    private String unit;

    @Property(name = "范围")
    private Integer range;

    @Relationship(type="疾病相关体征", direction = Relationship.INCOMING)
    private Set<Disease> diseases;

    @Relationship(type="实验室检查禁忌体征", direction = Relationship.INCOMING)
    private Set<LIS> conflict_lis = new HashSet<>();

    @Relationship(type="辅助检查禁忌体征", direction = Relationship.INCOMING)
    private Set<PACS> conflict_pacs = new HashSet<>();

//    @Relationship(type = "药品通用名禁忌体征", direction = Relationship.INCOMING)
//    private Set<Medicine> conflict_mediciness = new HashSet<>();

}
