package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @author zhoutg
 * @Description: 标准词转换
 * @date 2018年10月11日 下午3:33:22
 */

public enum StandConvertEnum implements KeyedNamed {

    lis(1, "lis"),
    pacs(2, "pacs"),
    disease(3, "disease"),
    drug(4, "drug"),
    symptom(5, "symptom"),
    operation(6, "operation"),
    vital(7, "vital");

    @Setter
    private int key;

    @Setter
    private String name;

    StandConvertEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static StandConvertEnum getEnum(int key) {
        for (StandConvertEnum item : StandConvertEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        StandConvertEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
