package com.diagbot.facade;

import com.diagbot.enums.StandConvertEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

/**
 * @Description:
 * @Author:zhoutg
 * @time: 2018/11/23 11:37
 */
@Component
public class CacheFacade {

    @Autowired
    @Qualifier("redisTemplateForSimilar")
    RedisTemplate redisTemplate;

    /**
     * 清除缓存信息
     *
     * @return
     */
    @CacheEvict(value = "cache", allEntries = true)
    public void clear() {

    }

    /**
     * 清除标准词转换缓存信息
     *
     * @return
     */
    public void clearStandConvert() {
        redisTemplate.delete(StandConvertEnum.disease.getName());
        redisTemplate.delete(StandConvertEnum.drug.getName());
        redisTemplate.delete(StandConvertEnum.lis.getName());
        redisTemplate.delete(StandConvertEnum.operation.getName());
        redisTemplate.delete(StandConvertEnum.pacs.getName());
        redisTemplate.delete(StandConvertEnum.symptom.getName());
        redisTemplate.delete(StandConvertEnum.vital.getName());
    }
}
