package com.diagbot.facade;

import com.diagbot.dto.CriticalNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.CriticalProcess;
import com.diagbot.util.ListUtil;
import com.diagbot.vo.CriticalNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @Description: 危急值facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class CriticalFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    CriticalProcess criticalProcess;

    /**
     * 高风险提示
     * @param
     * @return
     */
    public void criticalFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 危急值图谱接口调用
        CriticalNeoVO criticalNeoVOs = fillCriticalNeo(wordCrfDTO);
        List<CriticalNeoDTO> criticalNeoDTOList = neoFacade.getCritialNeo(criticalNeoVOs);

        // 危急值去重，否则结果出现重复数据
        if (ListUtil.isNotEmpty(criticalNeoDTOList)) {
            List<String> standNameList = new ArrayList<>();
            Iterator<CriticalNeoDTO> it = criticalNeoDTOList.iterator();
            while (it.hasNext()) {
                CriticalNeoDTO criticalNeoDTO = it.next();
                if (standNameList.contains(criticalNeoDTO.getStandname())) {
                    it.remove();
                } else {
                    standNameList.add(criticalNeoDTO.getStandname());
                }
            }
            // 规则处理
            criticalProcess.process(criticalNeoDTOList, wordCrfDTO, res);
        }
    }




    public CriticalNeoVO fillCriticalNeo(WordCrfDTO wordCrfDTO) {
        CriticalNeoVO criticalNeoVO = new CriticalNeoVO();

        criticalNeoVO.setAge(wordCrfDTO.getAge());
        criticalNeoVO.setSex(wordCrfDTO.getSex());
        criticalNeoVO.setVitalLabel(wordCrfDTO.getVitalLabel());
        criticalNeoVO.setLis(wordCrfDTO.getLis());


        return criticalNeoVO;
    }
}
