package com.diagbot.process;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.CriticalNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.enums.TypeEnum;
import com.diagbot.util.CoreUtil;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description: 危急值总入口
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class CriticalProcess {

    /**
     * 处理业务
     * @param criticalNeoDTOList
     * @param res
     */
    public void process(List<CriticalNeoDTO> criticalNeoDTOList, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        List<BillMsg> criticalList = res.getCriticalValList();
        for (CriticalNeoDTO critical : criticalNeoDTOList) {
            NodeNeoDTO nodeNeoDTO = critical.getCritical();
            // 化验
            if (TypeEnum.lis.getName().equals(critical.getType())) {
                List<Lis> lisList = wordCrfDTO.getLis();
                for (Lis bean : lisList) {
                    if (critical.getStandname().equals(bean.getUniqueName())) {
                        Map<String, Object> map = CoreUtil.compareLis(nodeNeoDTO, bean);
                        if ((Boolean) map.get("flag") == true) {
                            BillMsg criticalMsg = CoreUtil.getCommonCriticalMsg((String)map.get("msg"), TypeEnum.lis.getName());
                            criticalList.add(criticalMsg);
                        }
                    }
                }
            }

            // TODO 体征
        }
    }
}
