package com.diagbot.repository;


import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.OperationBillNeoDTO;
import com.diagbot.dto.OperationInfoDTO;
import com.diagbot.entity.node.Operation;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class OperationNode {


    public OperationBillNeoDTO OperationtoOperationDTO(Operation operation) {
        OperationBillNeoDTO opBillNeoDTO = new OperationBillNeoDTO();

        return opBillNeoDTO;
    }

    /**
     * 处理手术开单合理性
     */
    public List<BillNeoDTO> getOperationBill(Map<String, String> opterm, OperationRepository opRepository) {
        List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
        BillNeoDTO billNeoDTO;

        OperationBillNeoDTO opBillNeoDTO;

        String opname;

        for (String term : opterm.keySet()) {
            billNeoDTO = new BillNeoDTO();
            opname = opterm.get(term);
            billNeoDTO.setName(opname);

            List<Operation> operations = opRepository.findByNameIs(opname);

            if (null!=operations && operations.size()>0) {
                opBillNeoDTO = OperationtoOperationDTO(operations.get(0));
                billNeoDTO.setOperationBillNeoDTO(opBillNeoDTO);
            }

            billNeoDTOs.add(billNeoDTO);
        }

        return billNeoDTOs;
    }

    /**
     * 获取手术操作名称列表
     */
    public List<OperationInfoDTO> getOperationList(String name, OperationRepository operationRepository) {
        String nodename;

        List<OperationInfoDTO> opslist = new ArrayList<>();
        OperationInfoDTO opInfoDTO;

        List<Operation> operations = operationRepository.findByNameLike("*"+name+"*");

        for (Operation op : operations) {
            opInfoDTO = new OperationInfoDTO();
            nodename = op.getName();

            opInfoDTO.setName(nodename);
            opslist.add(opInfoDTO);
        }


        return opslist;
    }



    /**
     * 获取高危手术和操作数据
     */
    public List<HighRiskNeoDTO> getHighRiskOperation(Map<String, String> opsterm, OperationRepository operationRepository) {
        List<HighRiskNeoDTO> highRiskNeoDTOS = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO;
        String opname;
        Operation operation;

        for (String term : opsterm.keySet()) {
            highRiskNeoDTO = new HighRiskNeoDTO();

            opname = opsterm.get(term);
            highRiskNeoDTO.setName(term);
            highRiskNeoDTO.setStandname(opname);

            List<Operation> operations = operationRepository.findByNameIs(opname);

            if (null != operations) {
                operation = operations.get(0);
                if (null!=operation.getRisklevel() && operation.getRisklevel().trim().length()>0) {
                    highRiskNeoDTO.setIsHighrisk(true);
                    highRiskNeoDTO.setType("手术");
                    highRiskNeoDTOS.add(highRiskNeoDTO);
                }
            }
        }

        return highRiskNeoDTOS;
    }

}
