package com.diagbot.rule;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;

import java.util.List;
import java.util.Map;

/**
 * @description: 化验规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class LisRule {

    /**
     * 比较化验
     *
     * @param inputLis
     * @param billNeoMaxDTO
     * @return
     */
    public static void compareLisWithBill(List<Lis> inputLis, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getLis();
        if(ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLis)){
            for (NodeNeoDTO neo : neoList) {
                for (Lis lis : inputLis) {
                    String val = lis.getUniqueName();
                    if (StringUtil.isNotBlank(val) && val.equals(neo.getName())) {
                        Map<String, Object> map = CoreUtil.compareLis(neo, lis);
                        if ((Boolean) map.get("flag") == true) {
                            BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),
                                    billNeoMaxDTO.getOrderStandName(), (String)map.get("msg"), type);
                            billMsgList.add(commonBillMsg);
                        }
                    }
                }
            }
        }
    }
}
