package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import org.apache.commons.lang3.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description: 疾病规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class PacsRule {
    /**
     * 比较辅检
     *
     * @param drugLis
     * @param inputLis
     * @return
     */
    public static <T> void comparePacsWithBill(List<NodeNeoDTO> drugLis, List<T> inputLis, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        Map<String,String> old_stand = new HashMap<>();
        if(ListUtil.isNotEmpty(drugLis) && ListUtil.isNotEmpty(inputLis)){
            List<String> dl = drugLis.stream().map(x -> x.getName()).collect(Collectors.toList());
            for (T lis:inputLis) {
                String val = (String)CoreUtil.getFieldValue(lis, "uniqueName");
                String val_name = (String)CoreUtil.getFieldValue(lis, "name");
                if(StringUtils.isNotBlank(val) && dl.contains(val)){
                    old_stand.put(val_name,val);
                }
            }
        }
        if(old_stand.size() > 0){
            for (Map.Entry<String,String> d: old_stand.entrySet()) {
                BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(
                        billNeoMaxDTO.getOrderName(),billNeoMaxDTO.getOrderStandName(),
                        "已开" + d.getKey(), type);
                billMsgList.add(commonBillMsg);
            }
        }
    }
}
