package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.model.entity.Vital;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;

import java.util.List;
import java.util.Map;

/**
 * @description: 体征规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class VitalRule {

    /**
     * 比较体征
     *
     * @param inputLis
     * @param billNeoMaxDTO
     * @return
     */
    public static void compareVitalWithBill(List<Vital> inputLis, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getVitals();
        if(ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLis)){
            for (NodeNeoDTO neo : neoList) {
                for (Vital vit : inputLis) {
                    Map<String, Object> map = CoreUtil.compareVital(neo, vit);
                    if ((Boolean) map.get("flag") == true) {
                        BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),
                                billNeoMaxDTO.getOrderStandName(), (String) map.get("msg"), type);
                        billMsgList.add(commonBillMsg);
                    }
                }
            }
        }
    }
}
